Summary:	Parallel graph partitioning
Name:		parmetis
Version:	4.0.3
Release:	2
License:	GPL
Group:		Applications/Library
Source0:	parmetis-%{version}.tar.bz2
Source1:	metis.pdf
URL:		http://www-users.cs.umn.edu/~karypis/metis/parmetis/index.html
BuildRoot:	/var/tmp/%{name}-%{version}-root-%(id -u -n)
BuildArch:	x86_64 i686 i586 i486 i386
#BuildRequires:	mpich2-devel cmake >= 2.8
BuildRequires:	gcc gzip bzip2
#Conflicts:	metis
Obsoletes:	metis
Provides:	metis
Prefix:		/usr

%description
ParMetis is the parallel version of METIS, a set of programs for partitioning
graphs, partitioning finite element meshes, and for producing fill reducing
orderings for sparse matrices.

%prep
%setup -q -n parmetis-%version

%build
# Remove the directory 'programs' to avoid link errors
# (or add '-lstdc++' in the link cmdline)
sed -e 's/^add_subdirectory(programs)/#add_subdirectory(programs)/g' \
	CMakeLists.txt >tmp
/bin/mv -f tmp CMakeLists.txt

%ifarch x86_64
# Note: defining IDXTYPEWIDTH to 64 will force ParMETIS to use 64-bit ints,
# which breaks superlu-dist-3.3-1 and mumps-4.10.0-4
###sed -e 's/^#define IDXTYPEWIDTH .*$/#define IDXTYPEWIDTH 64/g' \
###	metis/include/metis.h >tmp
###/bin/mv -f tmp metis/include/metis.h
%endif

MPICC=`type -p mpicc`
MPICC_WRAP="`pwd`/mpicc"
cat <<END >$MPICC_WRAP
#/bin/bash
"$MPICC" -fPIC "\$@"
END
chmod +x $MPICC_WRAP
#make config shared=1 cc=$MPICC_WRAP prefix=${RPM_BUILD_ROOT}/usr
make config shared=not-set cc=$MPICC_WRAP prefix=${RPM_BUILD_ROOT}/usr
make

cd metis/GKlib
make

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
make install
# move /usr/lib to /usr/lib64 on x86_64
if test "$RPM_BUILD_ROOT%{_libdir}" != "$RPM_BUILD_ROOT/usr/lib"; then
    mv "$RPM_BUILD_ROOT/usr/lib" "$RPM_BUILD_ROOT%{_libdir}"
fi

# Install Metis (Note: ./build/Linux-i686/libmetis/libmetis.a)
cp metis/include/metis.h $RPM_BUILD_ROOT%{_includedir}/.
mkdir tmp
cd tmp
#---------- build libmetis.so
if false; then
   /bin/cp -p ../build/*/libmetis/libmetis.a \
	      ../metis/GKlib/build/*/libGKlib.a	$RPM_BUILD_ROOT%{_libdir}/.
else
   ar x ../build/*/libmetis/libmetis.a
   gcc -shared -o $RPM_BUILD_ROOT%{_libdir}/libmetis.so *.o
   /bin/rm -f *.o
   ar x ../metis/GKlib/build/*/libGKlib.a
   gcc -shared -o $RPM_BUILD_ROOT%{_libdir}/libGKlib.so *.o
   /bin/rm -f *.o
fi
#---------- build libparmetis.so
ar x $RPM_BUILD_ROOT%{_libdir}/libparmetis.a
rm -f $RPM_BUILD_ROOT%{_libdir}/libparmetis.a
gcc -shared -o $RPM_BUILD_ROOT%{_libdir}/libparmetis.so *.o
/bin/rm -f *.o
#---------- done
cd ..
rmdir tmp

cp manual/manual.pdf manual/parmetis.pdf
cp $RPM_SOURCE_DIR/metis.pdf manual/metis.pdf

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%files
%doc Changelog LICENSE.txt manual/parmetis.pdf manual/metis.pdf
/usr/include/*
/usr/lib*/lib*.*

%changelog
